if select(2,UnitClass("player")) ~= "MONK" then return end

local CreateFrame = CreateFrame
local GetSpellInfo = GetSpellInfo
local LibStub = LibStub
local select = select
local GetTotemInfo = GetTotemInfo
local GetTalentInfo = GetTalentInfo
local GetSpecialization = GetSpecialization
local GetBonusBarOffset = GetBonusBarOffset
local GetTime = GetTime
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local GetSpellCooldown = GetSpellCooldown
local UnitBuff = UnitBuff
local UnitAura = UnitAura
local GetHaste = GetHaste

local AceAddon = LibStub("AceAddon-3.0")
local SpiritedCrane = AceAddon:GetAddon("SpiritedCrane")

local frame = CreateFrame("Frame", nil , UIParent)
local bg
local icon

function SpiritedCrane:UpdatePosition()
	frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",SpiritedCrane.db.profile.pos_left,SpiritedCrane.db.profile.pos_top);
end

local function UpdateLeftTop()
	frame:StopMovingOrSizing()
	SpiritedCrane.db.profile.pos_left = frame:GetLeft()
	SpiritedCrane.db.profile.pos_top = frame:GetTop()
end

function SpiritedCrane:UpdateLock()
	if not SpiritedCrane.db.profile.lock then
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:SetScript("OnMouseDown", function() frame:StartMoving() end)
		frame:SetScript("OnMouseUp",UpdateLeftTop)
		frame:SetScript("OnDragStop", function() frame:StopMovingOrSizing() end)
	else
		frame:SetMovable(false)
		frame:EnableMouse(false)
		frame:SetScript("OnMouseDown", function() end)
		frame:SetScript("OnMouseUp", function() end)
		frame:SetScript("OnDragStop", function() end)
	end
end

function SpiritedCrane:UpdateSize()
	frame:SetSize(SpiritedCrane.db.profile.icon_size,SpiritedCrane.db.profile.icon_size) 
	if SpiritedCrane.db.profile.icon_size<4 then
		icon:SetSize(0,0) 
	else
		icon:SetSize(SpiritedCrane.db.profile.icon_size-4,SpiritedCrane.db.profile.icon_size-4)
	end
end

local refresh_rate = 0.1
local now_timer = 0
function SpiritedCrane:UpdateRefreshRate()
	refresh_rate = SpiritedCrane.db.profile.refresh_rate
	now_timer = 0
end

local expel_harm_texture = select(3,GetSpellInfo(115072))
local tiger_palm_texture = select(3,GetSpellInfo(100787))
local rising_sun_kick_texture = select(3,GetSpellInfo(107428))
local surging_mist_texture = select(3,GetSpellInfo(123273))
local thunder_focus_tea_texture = select(3,GetSpellInfo(116680))

local vital_mist_info = GetSpellInfo(118674)
local tiger_power_info = GetSpellInfo(125359)
local cranes_zeal_info = GetSpellInfo(127722)
local rising_sun_kick_info = GetSpellInfo(107428)
local chijis_guidance_info = GetSpellInfo(167717)
local mana_tea_info = GetSpellInfo(115867)
local surging_mist_chi_explosion
local expel_harm
local vital_mist
local tp_prepared_gcd
local bok_prepared_gcd
local rsk_prepared_gcd
function SpiritedCrane:UpdateSurgeCE()
	surging_mist_chi_explosion = SpiritedCrane.db.profile.surging_mist_chi_explosion
end

function SpiritedCrane:UpdateExpelHarm()
	expel_harm = SpiritedCrane.db.profile.expel_harm
end

function SpiritedCrane:UpdateVitalMist()
	vital_mist = SpiritedCrane.db.profile.vital_mist
end

function SpiritedCrane:UpdateTPPreparedGCD()
	tp_prepared_gcd = SpiritedCrane.db.profile.tp_prepared_gcd
end

function SpiritedCrane:UpdateBOKPreparedGCD()
	bok_prepared_gcd = SpiritedCrane.db.profile.bok_prepared_gcd
end

function SpiritedCrane:UpdateRSKPreparedGCD()
	rsk_prepared_gcd = SpiritedCrane.db.profile.rsk_prepared_gcd
end

local t17
function SpiritedCrane:UpdateT17()
	t17 = SpiritedCrane.db.profile.t17
end


local function ce_surge_pred(talent_ce)
	if talent_ce == true and surging_mist_chi_explosion == true and IsSpellInRange(GetSpellInfo(108557),"target")==0 then
		return true
	end
	return false
end

local function bok(chi,gtime)
	local d = select(7,UnitBuff("player",cranes_zeal_info,nil,"player"))
	local bok_prepared_time = bok_prepared_gcd * 1.5 / (1+GetHaste()/100)
	if 1<chi and ( d == nil or d<=bok_prepared_time+gtime ) then
		icon:SetTexture(select(3,GetSpellInfo(100784)))
		return true
	end
	return false
end
local function tp(chi,gtime,talent_ce)
	local d = select(7,UnitBuff("player",tiger_power_info,nil,"player"))
	local tp_prepared_time = tp_prepared_gcd * 1.5 / (1+GetHaste()/100)
	if ce_surge_pred(talent_ce) == false and 0< chi and ( d == nil or d<tp_prepared_time+gtime ) then
		icon:SetTexture(tiger_palm_texture)
		return true
	end
	return false
end
local function rsk(chi,gtime,talent_ce)
	local a,b = GetSpellCooldown(107428)
	if ce_surge_pred(talent_ce)==false and 1< chi and (a==0 or (a~=0 and b~=8) ) then
		if select(4,GetTalentInfo(7,3,1)) == true then
			icon:SetTexture(rising_sun_kick_texture)
			return true
		end
		local e = select(7,UnitAura("target",rising_sun_kick_info,nil,"PLAYER|HARMFUL"))
		local rsk_prepared_time = rsk_prepared_gcd * 1.5 / (1+GetHaste()/100)
		if e==nil or e<=rsk_prepared_time+gtime then
			icon:SetTexture(rising_sun_kick_texture)
			return true
		end
		if(IsSpellInRange(GetSpellInfo(107428),"mouseover")==1) then
			e = select(7,UnitAura("mouseover",rising_sun_kick_info,nil,"PLAYER|HARMFUL"))
			if e==nil or e<=rsk_prepared_time+gtime then
				icon:SetTexture(rising_sun_kick_texture)
				return true
			end
		end
	end
	return false
end

local function ce(chi)
	if 3<chi then
		icon:SetTexture(select(3,GetSpellInfo(157675)))
		return true
	end
	return false
end
local function tft(chi,chimax)
	if t17 == true and select(2,GetSpellCooldown(116680)) < 40 and chi+1 < chimax and select(4,UnitBuff("player",chijis_guidance_info,nil,"player")) == 2 then
		icon:SetTexture(thunder_focus_tea_texture)
		return true
	end
	return false
end

local function surge_vital_mist(chi,chimax)
	if vital_mist == true and chi<chimax and select(4,UnitBuff("player",vital_mist_info,nil,"player")) == 5 then
		icon:SetTexture(surging_mist_texture)
		return true
	end
	return false
end

local function surge(chi,chimax)
	if(ce_surge_pred() == true) and chi<chimax then
		return true
	end
	return false
end
local function em(chi,chimax)
	if expel_harm == true and chi<chimax then
		local a,b = GetSpellCooldown(115072)
		local c,d = GetSpellCooldown(147489)
		if (a==0 or (a~=0 and b~=15) ) and (c==0 or (c~=0 and d~=15) ) then
			icon:SetTexture(expel_harm_texture)
			return true
		end
	end
	return false
end
local function jab(chi,chimax,talent_ce)
	if ce_surge_pred(talent_ce)==false and chi<chimax then
		icon:SetTexture(select(3,GetSpellInfo(100780)))
		return true
	end
	return false
end
local function RotationRSK(chi,chimax)
	local gtime = GetTime()
	if 	surge_vital_mist(chi,chimax) ==true or
		bok(chi,gtime) == true or
		tp(chi,gtime) == true or
		rsk(chi,gtime,false) == true or
		bok(chi,gtime,false) == true or
		tft(chi,chimax) == true or
		surge(chi,chimax,false) == true or
		em(chi,chimax) == true or 
		jab(chi,chimax,false) == true then
		return
	end
	icon:SetTexture(select(3,GetSpellInfo(100784)))
end

local function RotationCE(chi,chimax)
	local gtime = GetTime()
	if 	surge_vital_mist(chi,chimax) ==true or
		tp(chi,gtime,true) == true or
		rsk(chi,gtime,true) == true or
		ce(chi,gtime) == true or
		tft(chi,chimax) == true or
		surge(chi,chimax,true) == true or
		em(chi,chimax) == true or 
		jab(chi,chimax,true) == true then
		return
	end
	icon:SetTexture(surging_mist_texture)
end


local function Update()
	local chi = UnitPower("player", 12)
	local chimax = UnitPowerMax("player", 12)
	if select(4,GetTalentInfo(7,2,1)) == true then
		RotationCE(chi,chimax)
	else
		RotationRSK(chi,chimax)
	end
end

local function on_update(self, elapsed)
	if refresh_rate<=now_timer then
		now_timer = 0
		if GetSpecialization()==2 and GetBonusBarOffset()==1 then
			Update()
			frame:Show()
		else
			frame:Hide()
		end
	else
		now_timer = now_timer + elapsed
	end
end
local on_update_frame = CreateFrame("Frame")
function SpiritedCrane:PLAYER_SPECIALIZATION_CHANGED()
	if GetSpecialization() == 2 then
		on_update_frame:SetScript("OnUpdate",on_update)
	else
		frame:Hide()
		on_update_frame:SetScript("OnUpdate",function()end)
	end
end

function SpiritedCrane:UpdateDB()
	self:UpdateLock()
	self:UpdatePosition()
	self:UpdateSize()
	self:UpdateRefreshRate()
	self:UpdateSurgeCE()
	self:UpdateExpelHarm()
	self:UpdateVitalMist()
	self:UpdateBOKPreparedGCD()
	self:UpdateRSKPreparedGCD()
	self:UpdateTPPreparedGCD()
	
	self:UpdateT17()
end

function SpiritedCrane:OnCoreInitialize()
	frame:SetFrameStrata("MEDIUM")
	frame:SetClampedToScreen(true)
	bg = frame:CreateTexture(nil, "BACKGROUND")
	bg:SetAllPoints(frame)
	bg:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background-Dark")
	bg:SetVertexColor(1,1,1,1)
	icon = frame:CreateTexture(nil, "BORDER")
	icon:SetPoint("CENTER", frame, "CENTER",0,0)
	icon:SetTexCoord(0.1,0.9,0.1,0.9)
	frame:Hide()
	SpiritedCrane:UpdateDB()
end
