if select(2,UnitClass("player")) ~= "MONK" then return end
local AceAddon = LibStub("AceAddon-3.0")
local SpiritedCrane = AceAddon:GetAddon("SpiritedCrane")
local SpiritedCrane_Options = AceAddon:NewAddon("SpiritedCrane_Options", "AceEvent-3.0","AceConsole-3.0")
--------------------------------------------------------------------------------------
local GetCVar = GetCVar
local string_match = string.match
local min = min
local cvar_width,cvar_height = string_match(GetCVar("gxResolution"), "(%d+)x(%d+)")
cvar_width = tonumber(cvar_width)
cvar_height = tonumber(cvar_height)
local cvar_min = min(cvar_width,cvar_height)
local string_format = string.format
local LibStub = LibStub
local AceDB = LibStub("AceDB-3.0")
local AceConfig = LibStub("AceConfig-3.0") -- For the options panel
local AceConfigDialog = LibStub("AceConfigDialog-3.0") -- Also for options panel
local AceDBOptions = LibStub("AceDBOptions-3.0") -- More database options
local AceConfigCmd =LibStub("AceConfigCmd-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale( "SpiritedCrane_Options" )
--------------------------------------------------------------------------------------
local order = 0
local function get_order()
	local temp = order
	order = order +1
	return temp
end

local options =
{
	type = "group",
	order = get_order(),
	name = "SpiritedCrane",
	args =
	{
		lock =
		{
			order = get_order(),
			name = L["Lock"],
			type = "toggle",
			set = function(info,val)
				SpiritedCrane.db.profile.lock = val
				SpiritedCrane:UpdateLock()
			end,
			get = function(info) return SpiritedCrane.db.profile.lock end,
			width = "full"
		},
		refreshRate =
		{
			type = "range",
			order = get_order(),
			name = L["Refresh Rate"],
			desc = L["unit : second"],
			min = 0,
			max = 2,
			step = 0.01,
			get = function () return SpiritedCrane.db.profile.refresh_rate end,
			set = function (_, v)
				SpiritedCrane.db.profile.refresh_rate = v
				SpiritedCrane:UpdateRefreshRate()
			end,
			width = "full"
		},
		Icon =
		{
			order = get_order(),
			name = L["Icon"],
			type = "group",
			args =
			{
				LeftPos = 
				{
					type = "range",
					order = get_order(),
					name = L["Left Position"],
					min = 0,
					max = cvar_width,
					step = 0.1,
					get = function () return SpiritedCrane.db.profile.pos_left end,
					set = function (_, v)
						SpiritedCrane.db.profile.pos_left = v
						SpiritedCrane:UpdatePosition()
					end
				},
				TopPos = 
				{
					type = "range",
					order = get_order(),
					name = L["Top Position"],
					min = 0,
					max = cvar_height,
					step = 0.1,
					get = function () return SpiritedCrane.db.profile.pos_top end,
					set = function (_, v)
						SpiritedCrane.db.profile.pos_top = v
						SpiritedCrane:UpdatePosition()
					end
				},
				Size =
				{
					type = "range",
					order = get_order(),
					name = L["Size"],
					min = 10,
					max = cvar_min,
					step = 0.1,
					get = function () return SpiritedCrane.db.profile.icon_size end,
					set = function (_, v)
						SpiritedCrane.db.profile.icon_size = v
						SpiritedCrane:UpdateSize()
					end
				},
			}
		},
		Calculation =
		{
			order = get_order(),
			name = L["Calculation"],
			type = "group",
			args =
			{
				ExpelHarm =
				{
					order = get_order(),
					name = GetSpellInfo(115072),
					type = "toggle",
					set = function(info,val)
						SpiritedCrane.db.profile.expel_harm = val
						SpiritedCrane:UpdateExpelHarm()
					end,
					get = function(info) return SpiritedCrane.db.profile.expel_harm end,
					width = "full"
				},
				SurgMCE =
				{
					order = get_order(),
					name = string_format(L["Rotation: %s<-->%s"],GetSpellInfo(123273),GetSpellInfo(159620)),
					type = "toggle",
					set = function(info,val)
						SpiritedCrane.db.profile.surging_mist_chi_explosion = val
						SpiritedCrane:UpdateSurgeCE()
					end,
					get = function(info) return SpiritedCrane.db.profile.surging_mist_chi_explosion end,
					width = "full"
				},
				VitalMist =
				{
					order = get_order(),
					name = GetSpellInfo(118674),
					type = "toggle",
					set = function(info,val)
						SpiritedCrane.db.profile.vital_mist = val
						SpiritedCrane:UpdateVitalMist()
					end,
					get = function(info) return SpiritedCrane.db.profile.vital_mist end,
					width = "full"
				},
				
				T17=
				{
					order = get_order(),
					name = GetSpellInfo(167717),
					type = "toggle",
					set = function(info,val)
						SpiritedCrane.db.profile.t17 = val
						SpiritedCrane:UpdateT17()
					end,
					get = function(info) return SpiritedCrane.db.profile.t17 end,
					width = "full"
				},
				TPPreparedGCD = 
				{
					type = "range",
					order = get_order(),
					name = string_format(L["%s prepared gcd(s)"],GetSpellInfo(100787)),
					desc = L["unit : gcd"],
					min = 0,
					max = 10,
					step = 0.1,
					get = function () return SpiritedCrane.db.profile.tp_prepared_gcd end,
					set = function (_, v)
						SpiritedCrane.db.profile.tp_prepared_gcd = v
						SpiritedCrane:UpdateTPPreparedGCD()
					end,
					width = "full"
				},
				BOKPreparedGCD = 
				{
					type = "range",
					order = get_order(),
					name = string_format(L["%s prepared gcd(s)"],GetSpellInfo(100784)),
					desc = L["unit : gcd"],
					min = 0,
					max = 10,
					step = 0.1,
					get = function () return SpiritedCrane.db.profile.bok_prepared_gcd end,
					set = function (_, v)
						SpiritedCrane.db.profile.bok_prepared_gcd = v
						SpiritedCrane:UpdateBOKPreparedGCD()
					end,
					width = "full"
				},
				RSKPreparedGCD =
				{
					type = "range",
					order = get_order(),
					name = string_format(L["%s prepared gcd(s)"],GetSpellInfo(107428)),
					desc = L["unit : gcd"],
					min = 0,
					max = 10,
					step = 0.1,
					get = function () return SpiritedCrane.db.profile.rsk_prepared_gcd end,
					set = function (_, v)
						SpiritedCrane.db.profile.rsk_prepared_gcd = v
						SpiritedCrane:UpdateRSKPreparedGCD()
					end,
					width = "full"
				},
			}
		}
	}
}
local optionsFrames = {}
function SpiritedCrane_Options:OnInitialize()
	options.args.profile = AceDBOptions:GetOptionsTable(SpiritedCrane.db)
	AceConfig:RegisterOptionsTable("SpiritedCrane", options, nil)
	optionsFrames.general = AceConfigDialog:AddToBlizOptions("SpiritedCrane", "SpiritedCrane")
	SpiritedCrane.db.RegisterCallback(SpiritedCrane, "OnProfileChanged", "UpdateDB")
	SpiritedCrane.db.RegisterCallback(SpiritedCrane, "OnProfileCopied", "UpdateDB")
	SpiritedCrane.db.RegisterCallback(SpiritedCrane, "OnProfileReset", "UpdateDB")
end